' .ApplicationSource APL-ChangeSequence(1.7)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 13 January 1995 at 3:56:17 pm'!



"fix: mnu #asSymbol when trying to backup changed code for methods with nil protocol"!

!ChangeSequence methodsFor: 'change management'!

 !                                                                                                                                                                                                                                                                                                                                                                            

"fix: Loss of new elements in a Changes editor was possible"!

!EnhancedChangeList methodsFor: 'changing'!

 !                                                                                                                                                                                                                                                                                                                                                                                                                                                   

"code maintenance"!

ChangeSequenceController removeSelector: #addDoIt!

ChangeSequence removeSelector: #updateChanges!


' .ApplicationSource APL-ChangeSequence(1.8)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 13 January 1995 at 4:42:40 pm'!



!EnhancedChangeList methodsFor: 'changing'!

 !                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 


' .ApplicationSource APL-ChangeSequence(1.9)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 17 January 1995 at 12:02:33 pm'!



"adapt to new handling of source/changes file references in Change objects since version 1.10 of ExternalSource (version 1.12 for VisualWorks 2.0)"!

!ChangeSequence methodsFor: 'change management'!

commentClass: className 
	"assume that the current comment source resides in the changes file"

	| cm |
	((cm := className asClass organization globalComment) isKindOf: RemoteString)
		ifFalse: [self error: 'RemoteString expected'].
	self add: ((ClassCommentChange file: cm sourceFileNumber position: cm sourceKey)
			className: className;
			type: #comment)! !

!ChangeSequence methodsFor: 'change management'!

backupSelector: selector protocol: protocol class: className 
	"create (and return) a change object which saves the source code info for the 
	specified method"

	| chg |
	chg := MethodDefinitionBackup new className: className; selector: selector; getSource.
	^(chg file == nil or: [chg sourceFileNumber == 2])
		ifFalse: 
			["backup stored versions only"
			protocol == nil ifFalse: [chg category: protocol].
			self add: chg]! !


' .ApplicationSource APL-ChangeSequence(1.10)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 17 January 1995 at 1:22:36 pm'!



!MethodDefinitionBackup methodsFor: 'fileIn/Out'!

representBinaryOn: binWriter 
	"special representation if inst var 'file' refers to an external stream"

	^(file isInteger or: [file isKindOf: ExternalStream])
		ifTrue: [MessageSend
				receiver: self class
				selector: #selector:class:
				arguments: (Array with: self selector with: self className)]
		ifFalse: [super representBinaryOn: binWriter]! !


' .ApplicationSource APL-ChangeSequence(1.11)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 17 January 1995 at 2:09:16 pm'!



!EnhancedChangeList methodsFor: 'changing'!

changeRequest
	"check if the current list holds new elements"

	| mode src |
	(mode := self mode) == nil ifTrue: [^true].
	src := application perform: mode.
	changes detect: [:chg | (src includes: chg) not and: [chg text ~= '"- end of history -"']]
		ifNone: [^true].
	(self listName findString: 'Changes conflicts in upgrading ' startingAt: 1) == 1
		ifTrue: [^true].	
	
	mode := DialogView
				choose: 'The list seems to have new elements'
				labels: #('Forget and close' "'Save and close'" 'Do not close' )
				values: #(true "0" false )
				default: false.
	mode == 0 ifTrue: [self acceptList. mode := true].
	^mode! !


' .ApplicationSource APL-ChangeSequence(1.12)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 7 April 1995 at 5:37:30 pm'!



"reduced output when filing out changes (avoid superfluous protocol headers)"!

!ChangeSequence methodsFor: 'file out'!

fileOutOn: aStream 
	| prev suc |
	prev := nil. suc := 1.
	self do: 
		[:chg | 
		chg
			fileOutOn: aStream
			previous: prev
			next: (suc = self size ifFalse: [self at: (suc := suc + 1)]).
		prev := chg]! !

"bug fix: 
- changes referring to discarded source code after condense changes
	(some change objects cannot be resolved to source code,
	especially method changes followed by a method remove,
	but also method changes referring to renamed classes)
- class renames have to be propagated to change sequence elements
	(method changes might refer to old names of renamed classes until 
	newly compiled)"!

!ChangeSequence methodsFor: 'change management'!

updateCondensed
	"condensing changes invalidates source references of change objects with 
	code in the changes file; update correct source references"

	self removeAllSuchThat: [:chg | (chg isKindOf: MethodDefinitionChange)
			ifTrue: [chg sourceFileNumber = 2 and: [chg methodInSystem not
						or: 
							[chg getSource.
							false]]]
			ifFalse: 
				["especially comment changes"
				chg getSource.
				false]]! !

!ClassRelatedChange methodsFor: 'accessing'!

renameClass: aSymbol to: newName 
	"if the receiver refers to class name aSymbol then change to newName; 
	return true/false to indicate if a change was performed"

	^self className == aSymbol asSymbol
		and: [self className: newName. true]! !

!ClassDefinitionChange methodsFor: 'accessing'!

superclassName
	superclassName == nil ifTrue: [superclassName := (file reset; upTo: Character space) asSymbol].
	^superclassName! !

!ClassDefinitionChange methodsFor: 'accessing'!

renameClass: oldName to: newName 
	"exchange class name references properly as well as the text 
	(uses knowledge of class declaration format); 
	return true/false to indicate if a change was performed"

	| oldsym |
	className == (oldsym := oldName asSymbol)
		ifTrue: 
			[self text: ((WriteStream on: (String new: 200))
				nextPutAll: (file reset; through: $#);
				nextPutAll: newName; crtab;
				nextPutAll: (file throughAll: className; nextChunk);
				contents).
			self className: newName.
			^true].

	"check superclass"
	^self superclassName == oldsym
		and: 
			[self text: ((WriteStream on: (String new: 200))
				nextPutAll: newName; space;
				nextPutAll: (file reset; upTo: Character space; nextChunk);
				contents).
			superclassName := newName asSymbol.
			true]! !

!ClassDefinitionBackup methodsFor: 'accessing'!

renameClass: aSymbol to: newName 
	"ignore any rename requests"

	^false! !

!ClassOtherChange methodsFor: 'accessing'!

renameClass: oldName to: newName 
	^self type == #rename
		ifTrue: 
			["check if the new rename overwrites the receiver"
			(file reset; next) == $" ifTrue: [^false].
			file skipThrough: Character space; skipThrough: Character space.
			(String readFrom: file) = oldName asString
				and: 
					["since class renames are propagated immediately this 
					change should be obsolete; discard its text"
					self text: ('"' , self text copyWith: $").
					false]]
		ifFalse: [super renameClass: oldName to: newName]! !

!OtherChange methodsFor: 'accessing'!

renameClass: className to: newName 
	"exchange text occurrences of className with newName"

	| txt start |
	^(start := (txt := self text) findString: className startingAt: 1) > 0
		and: 
			[| prs stop |
			prs := self class parserClass new.
			(start = 1 or: [(prs isTokenish: (txt at: start - 1)) not])
				and: [((stop := start + className size) > txt size or: [(prs isTokenish: (txt at: stop)) not])
					and: 
						[self text: (txt copyReplaceFrom: start to: stop with: newName).
						self renameClass: className to: newName.
						true]]]! !

!ChangeSequence methodsFor: 'change management'!

renameAllClass: className to: newName 
	"a class has been renamed; change name references of change elements; 
	return the index for proper insertion of a rename change (nil if no such 
	index exists)"

	| index oldMeta newMeta |
	index := nil.
	1 to: self size do:
		[:idx | | chg |
		(((chg := self at: idx) renameClass: className to: newName)
				and: [index == nil])
			ifTrue:
				[(chg isKindOf: ClassDefinitionChange)
					ifTrue:
						["leave this change unrenamed; a rename should be inserted behind"
						chg renameClass: newName to: className.
						index := idx + 1]
					ifFalse: [index := 0]]].

	oldMeta := (className, ' class') asSymbol.
	newMeta := (newName, ' class') asSymbol.
	self do: [:chg | chg renameClass: oldMeta to: newMeta].
	^index = 0 ifFalse: [index]! !

!ChangeSequence methodsFor: 'change management'!

renameClass: className to: newName 
	"add a class rename change to the receiver;
	propagate the rename to each element immediately"

	| chg index |
	chg := ClassOtherChange new
			className: className;
			type: #rename;
			text: className, ' ', #rename:, ' ', newName storeString.
	(index := self renameAllClass: className to: newName) == nil
		ifTrue: [self add: chg]
		ifFalse: [self insert: chg before: index]

	"ChangeScanner inserts a second change, but we don't "
"	self add: (ClassOtherChange new className: newName; type: 'rename to' asSymbol)"! !