' .ApplicationSource APL-Framework(1.15)'!
'From VisualWorks(R) Release 2.0 of 4 August 1994 on 24 January 1995 at 11:10:39 am'!



"fix: invalid source pointers after exclude class/category (Source code not available)"!

!SystemApplication methodsFor: 'classes'!

includeClass: aClass 
	"return nil if another application holds the definition of aClass;
	otherwise include aClass (structure and definition) and return it"

	(self applicationManagement applicationsIncludingDefinition: aClass) isEmpty
		ifFalse: [^nil].
	(self classSubsetOf: aClass ifAbsent: [self addClassSubset: aClass]) addDefinition.
	^aClass! !

!SystemApplication methodsFor: 'selectors'!

includeSelector: selector class: aClass changes: aChangeSequence
	"register class>selector in the application structure (if no other application holds it); 
	remove appropriate changes from aChangeSequence and enter necessary changes 
	for the receiver"

	| selChgs |
	selChgs := aChangeSequence removeSelectorChanges: selector class: aClass.
	(self applicationManagement applicationsIncludingSelector: selector class: aClass) isEmpty
		ifFalse:
			["assume each app found (incl. sys) has all changes due to continuous change logging"
			^self].

	Transcript cr; show: aClass name , '>' , selector , ' included in System Application'.
	self includeSelector: selector class: aClass.
	"enter changes for aClass/selector (include change if none)"
	selChgs isEmpty
		ifTrue: [self changes includeSelector: selector protocol: (self protocolFor: selector class: aClass) class: aClass]
		ifFalse: [self changes addAll: selChgs]! !

!Application methodsFor: 'changing-classes'!

includeOrChangeClass: aString
	"aString is the definition string of a class;
	create/change the class if necessary; include it to the receiver's registry;
	return the class object
	(sent during file in only, when the receiver is the currently logging application)"

	| cls |
	cls := (ReadStream on: aString) skipThrough: $#; upTo: Character cr.
	^((cls := cls asClass) == nil or: [cls definition ~= aString])
		ifTrue: [Object evaluatorClass evaluate: aString]
		ifFalse: [self includeClass: cls. cls]! !

!Application methodsFor: 'changing-classes'!

excludeClass: aClass 
	"exclude aClass, its definition and all its methods from application;
	move selectors and changes not held in other applications to system app.;
	enter exclude changes after removing all others"

	| subset cls clsChgs sys srcChgs sysOldChgs |
	(subset := self removeClassSubset: aClass) == nil ifTrue: [^nil].
	clsChgs := self changes removeClassChanges: (cls := aClass asClass).
	srcChgs := clsChgs shallowCopy.
	sysOldChgs := (sys := self systemApplication) changes shallowCopy.

	"move class definition, selectors and changes to sys (if not held elsewhere)"
	subset selectors do:
		[:sel | 
		sys includeSelector: sel class: cls changes: clsChgs.
		self changes excludeSelector: sel class: cls name].
	subset includesDefinition
		ifTrue:
			[(sys includeClass: cls) == nil ifFalse: [sys addChanges: clsChgs].
			self changes excludeClass: cls name].
	self touch.

	"keep original ordering of class changes"
	(clsChgs := sys changes copyFrom: sysOldChgs size + 1 to: sys changes size) isEmpty
		ifTrue: [^self].
	srcChgs do: [:chg | | idx |
		(idx := clsChgs indexOf: chg) > 0
			ifTrue: [sysOldChgs add: chg. clsChgs at: idx put: nil]].
	clsChgs do: [:chg | chg == nil ifFalse: [sysOldChgs add: chg]].
	sys setChanges: sysOldChgs! !

!Application methodsFor: 'changing-selectors'!

excludeSelector: selector class: aClass 
	"selector is excluded from application, included into system application; 
	all recorded changes move to system application"

	(self removeSelector: selector inSubsetOf: aClass) == nil ifTrue: [^nil]. 
	self systemApplication includeSelector: selector class: aClass changes: self changes.
	"enter an exclude change after removing all others"
	self changes excludeSelector: selector class: aClass.
	self touch! !

"bug fixes:
- misbehavior/errors in 'set directories' for initial applications with ext. source
- release source file after changing the platform compatible name
- filing in class definitions entered changes in peculiar ordering (includeOrChange + backup + change)
- mistakes in scanning the version map file"!

!ApplicationManagement methodsFor: 'accessing'!

changePaths
	"show a menu of paths used by registered applications; selecting one opens a 
	dialog for entering a new path, all references to the selected path will be 
	replaced by the new one"

	| allpaths oldpath newpath apps selectedapps initial |
	allpaths := Set new.
	applications do: [:app | (oldpath := app path) == nil
		ifFalse:
			[| p |
			p := oldpath asString.
			(OSErrorHolder errorSignal handle: [:ex | ex returnWith: false] do: [oldpath exists])
				ifFalse: [p := p asText allBold].
			allpaths add: p]].
	oldpath := allpaths asSortedCollection select: 'Select a path to modify' fromUserIfEmpty: [^nil].
	oldpath := oldpath asString.
	apps := applications select:
				[:app | | p |
				(p := app path) notNil and: [p asString = oldpath]].
	selectedapps := ApplicationBrowser
				multipleSelect: (apps collect: [:app | app name])
				prompt: 'Select applications to change path \''' withCRs , oldpath , ''''
				onCancel: [^nil].
	selectedapps isEmpty ifTrue: [^nil].
	apps := apps select: [:app | selectedapps includes: app name].
	initial := apps first version isInitialVersion.
	newpath := DialogView
				requestFileName: 'Enter the new ', (initial ifTrue: ['file'] ifFalse: ['path'])
				default: oldpath
				version: (initial ifTrue: [#mustBeOld] ifFalse: [#directory])
				ifFail: [^nil].
	apps do: [:app | app setPath: newpath]! !

!Application methodsFor: 'filenames'!

requestPlatformNamesOnCancel: aBlock 
	"open a dialog to define application names compatible to supported platforms; 
	return the name map (result of aBlock on cancel)"

	| map |
	map := ApplicationBrowser
				request: 'Enter platform compatible names for\''' withCRs , self identifier , ''''
				platformNames: self label platformNameMap
				default: self name
				onCancel: [^aBlock value].
	map keysAndValuesDo: [:pf :pfname | pfname isEmpty
			ifFalse: 
				[self label setFilename: pfname forPlatform: pf.
				pf == OSHandle currentOS ifTrue: [self releaseSourceFile]]].
	^map! !

!ChangeSequence methodsFor: 'change management'!

backupClass: aClass 
	"create a change object saving the source code info for the given class;
	after compilation of a class a ClassBuilder informs the change management, 
	inducing a call to this method (via ChangeSet, App...Management, Application);
	to get source before compilation we 'ask someone in the stack'
	(the appropriate handler is expected in ClassBuilder>modifyExistingClass);
	return nil if no backup was possible, a dummy change if definition is equal,
	the newly entered backup change otherwise"

	| oldsrc |
	oldsrc := Signal noHandlerSignal
		handle: [:ex | ex return]	"no class definition text available"
		do: ["try to get a class definition text"
			self applicationManagement class sourceSignal raiseRequest].
	^oldsrc isString ifTrue: [oldsrc = aClass definition
			ifTrue: [OtherChange new]
			ifFalse: [self add: (ClassDefinitionBackup new className: aClass name; text: oldsrc)]]! !

!Application methodsFor: 'changing-classes'!

changeOrIncludeClass: aClass 
	"definition of aClass changed in the scope of the receiver; include it with 
	definition if necessary, and make backup, include/change entries to changes"

	| bak |
	bak := self changes backupClass: aClass.
	(self includesClass: aClass)
		ifTrue: [self changes changeClass: aClass]
		ifFalse: 
			[self includeClass: aClass.
			(bak == nil or: [bak isBackup])
				ifTrue: 
					["class is new or truely changed; replace the include change"
					| chg |
					((chg := self changes last) className == aClass name
						and: [chg type == #includeOrChangeClass:])
						ifTrue: [self changes removeLast; changeClass: aClass]]]! !

!Application methodsFor: 'private'!

getMinorVersionPosition: aVersion 
	"return a file index for the beginning of sources for aVersion;
	return source file size if aVersion is not yet written"

	^InputState default shiftDown
		ifTrue: 
			[| stream pos |
			stream := self versionFileName readStream.
			pos := nil.
			[pos == nil and: [stream atEnd not]]
				whileTrue: 
					[(Integer readFrom: stream) = aVersion minor
						ifTrue: [pos := Integer readFrom: (stream skip: 1)]
						ifFalse: [stream skipThrough: Character cr]].
			stream close.
			pos]
		ifFalse: 
			[| pos key |
			key := self class sourceHeader , self name , '(' , aVersion printString , ')'.
			(pos := ChangeList new findLast: key in: self sourceFile) == nil
				ifTrue: [self sourceFile size]
				ifFalse: [pos - key size - 1]]! !

"enhanced product version access"!

!ApplicationManagement class methodsFor: 'installation'!

producerAddress
	"return the address of company Georg Heeg Objektorientierte Systeme"

	^'Georg Heeg Objektorientierte Systeme\Baroper Str. 337\44227 Dortmund' withCRs! !

!ApplicationManagement class methodsFor: 'installation'!

producerLogo
	"return the logo of company Georg Heeg Objektorientierte Systeme"

	| im shape palClass colorClass |
	palClass := Smalltalk at: #VariablePalette ifAbsent: [MappedPalette].
	colorClass := Smalltalk at: #MappedColorValue ifAbsent: [ColorValue].
	im := Image
				extent: 46 @ 36
				depth: 2
				palette: (palClass
						with: colorClass white
						with: (colorClass red: 0.6 green: 0.1 blue: 0.1)
						with: (colorClass brightness: 0.7))
				bits: (ByteArray fromPackedString: '@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@UUUUT@@@@@@@@@UUP@@@ET@@@@@@@UT@@@@E@E@@@@@@UT@@@@@U@E@@@@@ET@@@@@ATDT@@@@AT@@@@@@APUP@@@@UP@@@@@AUUU@@@@AT@@@@@@@UUP@@@@EP@@@@@@ATE@@@@@U@@@@U@@EPU@@@@AT@@@ET@@EAT@@@@AP@@ATPP@UAP@@@@AT@AUQQ@ATEP@@@@@UUUPATEUUUUUUU@@EUP@EPUUUUUUUT@@@@@@U@@UAT@@@@@@@@@AT@ATEP@@@@@@@@@EP@EPU@@@@@@@@@@U@@EQU@@@@@@@@@AT@@UAT@@@@@@@@@EP@ATEP@@@@@@@@@UP@EPU@@@@@@@@@AU@@EPU@@@@@@@@@EE@@UAT@@@@@@@@@TT@ATAP@@@@@@@@APP@EPEP@@@@@@@@AQQTE@UAT@@@@@@@AUATE@TAT@@@@@@@@T@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@B**************@B**************@@@@@@@@@@@@@@@@@').
	shape := im
				convertToPalette: CoveragePalette monoMaskPalette
				renderedBy: NearestPaint new
				paintTransfer: [:pix | pix red = 1
						ifTrue: [CoverageValue transparent]
						ifFalse: [CoverageValue opaque]].
	^OpaqueImage figure: (CachedImage on: im)
		shape: (CachedImage on: shape)! !

!ApplicationManagement class methodsFor: 'installation'!

productInfo
	"open a dialog showing the product info text (product name, version, date, producer, etc)"
	"ApplicationManagement productInfo"

	| dialog addLabel |
	(dialog := DialogView model: self)
		width: 300;
		addVerticalSpace: 24;
		addVisual: self producerLogo fromX: 0 toX: 0.2;
		yPosition: 24.

	addLabel := [:string :title | | txt |
		txt := string asText emphasizeAllWith: (title ifTrue: [#(large bold)]).
		dialog addVisual: txt asComposedText fromX: 0.2 toX: 1].

	addLabel value: self productIdentifier value: true.
	dialog addVerticalSpace: 24.
	addLabel value: ' 1993-1995 by' value: false.
	dialog addVerticalSpace: 8.
	addLabel value: self producerAddress value: false.
	dialog
		addVerticalSpace: 24;
		addWrapper: (BoundedWrapper on: (Button trigger
			model: ((PluggableAdaptor on: dialog controller) performAction: #accept);
			label: 'OK')) atX: 0.5;
		addVerticalSpace: 8;
		open! !

!ApplicationManagement class methodsFor: 'installation'!

productVersion
	"return the version number of this Application Management (i.e. 1.2)"

	^VersionDescriptor major: 1 minor: 2! !

"code maintenance:
- write section headings into source file
- do not store doit change text externally"!

!Application methodsFor: 'private-fileIn/Out'!

fileOutHeading: aString on: aSourceStream 
	"store the name of a section in an application source code file 
	format: '- <section name> of <appl. name and version> -' "

	| str |
	str := ('- <section> of <id> -'
				copyReplaceAll: '<section>' with: aString)
				copyReplaceAll: '<id>' with: self identifier.
	aSourceStream cr; cr; store: str storeString! !

!Application methodsFor: 'private-fileIn/Out'!

fileOutSourcesOn: fileStream 
	self fileOutHeading: 'sources' on: fileStream.
	self fileOutClasses: self classNames on: fileStream! !

!Application methodsFor: 'private-fileIn/Out'!

fileOutDocumentationOn: aSourceStream 
	"write a message which can be sent to application management"

	documentation == nil ifTrue: [^self].
	self fileOutHeading: 'comment' on: aSourceStream.
	aSourceStream cr; cr; store: (Message selector: #documentation: arguments: (Array with: self documentation)) storeString! !

!Application methodsFor: 'private-fileIn/Out'!

fileOutRequiredOn: aSourceStream 
	"avoid doits which cannot be evaluated for users without application 
	management; return a message which can be sent to application 
	management"

	self necessary isEmpty ifTrue: [^self].
	self fileOutHeading: 'required applications' on: aSourceStream.
	aSourceStream cr; cr; store: (Message selector: #checkRequired: arguments: (Array with: self necessary asArray)) storeString! !

!Application methodsFor: 'private-fileIn/Out'!

fileOutPreInstallationOn: aSourceStream 
	"write the list of expressions which prepare the installation of the receiver"

	| list |
	(list := self preInstallation) isEmpty ifTrue: [^self].
	self fileOutHeading: 'installation' on: aSourceStream.
	list fileOutOn: aSourceStream targetFile cr cr! !

!Application methodsFor: 'private-fileIn/Out'!

fileOutPostInstallationOn: aSourceStream 
	"write the list of expressions which finalize the installation of the receiver"

	| list |
	(list := self postInstallation) isEmpty ifTrue: [^self].
	self fileOutHeading: 'post-installation' on: aSourceStream.
	list fileOutOn: aSourceStream targetFile cr cr! !

SystemApplication removeSelector: #latestMinor!


' .ApplicationSource APL-Framework(1.16)'!
'From VisualWorks(R) Release 2.0 of 4 August 1994 on 16 February 1995 at 11:48:13 am'!



"forgotten changes for bug fix against invalid source pointers after exclude class/category"!

!Application methodsFor: 'changing-selectors'!

excludeSelector: selector class: classOrSymbol 
	"selector is excluded from application, included into system application; 
	all recorded changes move to system application"

	(self removeSelector: selector inSubsetOf: classOrSymbol) == nil ifTrue: [^nil].
	self systemApplication
		includeSelector: selector
		class: classOrSymbol asClass
		changes: self changes.
	"enter an exclude change after removing all others"
	self changes excludeSelector: selector class: classOrSymbol.
	self touch! !

!MethodApplicationChange methodsFor: 'accessing'!

text
	"avoid doits which cannot be evaluated for users without application management;
	return a message which can be sent to application management"

	type == #exclude
		ifFalse: [self error: 'Unsupported type of MethodApplicationChange: ' , type].
	^(Message
		selector: #excludeSelector:class:
		arguments: (Array with: self selector with: self className)) storeString! !

"fix: avoid outdated application list"!

!ApplicationManagement methodsFor: 'change management'!

updateApplicationList
	"broadcast a change on the application registry"

	self changed: #version! !

!ApplicationManagement methodsFor: 'registration'!

register: anApplication ifRegistered: aBlock 
	"enter anApplication in the application holder; 
	ensure unique application names, evaluate aBlock on violation"

	(self includesNamed: anApplication name)
		ifTrue: [^aBlock value].
	applications add: anApplication.
	applications := (applications asSortedCollection: [:x :y | x name < y name]) asOrderedCollection.
	self updateApplicationList! !

!Application methodsFor: 'version management'!

version: aVersionDescription 
	self label version: aVersionDescription.
	self changed: #version.
	self applicationManagement updateApplicationList! !

!Application methodsFor: 'accessing-changes'!

setChanges: changeSequence 
	"absolute assignment to changes, keeping version consistent"

	| vers |
	(changes := changeSequence) isEmpty == (vers := self version) modified
		ifTrue: [self version: (vers perform: (changes isEmpty
					ifTrue: [#untouch]
					ifFalse: [#touch]))]
		ifFalse: ["modification state matches empty changes"]! !

"improved file-in (loading and upgrade):
- reorg. responsibility for file-in functionality (PeekableStream -> Application)
- pass version specifiers in the file to application and ApplicationManager
- evaluate section headings to catch pre/post-installation doits"!

!Application methodsFor: 'private-fileIn/Out'!

evaluateSpecial: aStringOrMessage chunk: codeString mode: aValueHolder 
	"aStringOrMessage has been encountered on a file-in stream; 
	check if it is a valid command, execute it and return its result;
	register changes with respect to source file section given by aValueHolder"

	| string section chglist |
	(string := aStringOrMessage) isString
		ifTrue:
			["check for version or source file section specifiers"
			| key |
			(string findString: (key := self class sourceHeader) startingAt: 1) == 1
				ifTrue:
					["encountering a version specifier"
					^((string := string readStream) skip: key size; upTo: $() = self name
						ifTrue:
							[aValueHolder value: 'patches'.
							VersionDescriptor readFrom: string]
						ifFalse: [nil	"source header of some other application"]].
			(string isEmpty not and: [string first == $- and: ['- * of ', self name, '* -' match: string]])
				ifTrue:
					["encountering a section heading"
					string := string readStream skip: 2; upTo: Character space.
					aValueHolder value: string.
					^string]]
		ifFalse: [(aStringOrMessage isKindOf: Message)
			ifTrue: [^self applicationManagement performMessage: aStringOrMessage]].

	"register changes with respect to current source file section"
	section := #("'comment' 'required'" 'installation' "'sources'" 'post-installation' 'patches')
				indexOf: aValueHolder value ifAbsent: [^string].
	chglist := self perform: (#(#preInstallation #postInstallation #changes) at: section).
	(codeString includes: $.)
		ifTrue: [chglist addDoIt: codeString]
		ifFalse: [ChangeScanner new scanFile: codeString readStream
					do: [:chg | chglist add: chg]].
	section <= 2 ifTrue:
		[self perform: (#(#setPreInstallation: #setPostInstallation:) at: section) with: chglist].
	^string! !

!Application methodsFor: 'private-fileIn/Out'!

fileInExternal: aStream stop: stopVersion
	"(rewritten from PeekableStream>fileIn + checking occurences of special do its) 
	file in from aStream, start at current position, new version spec should follow immediately,
	stop encountering stopVersion (end of file, if not found);
	compile w/o logging to changes file, 
	construct non-default source code pointers for generated methods;
	update version at each occurrence of version specifiers" 

	| signal evaluator val prevVers nextVers section |
	signal := self applicationManagement class sourceSignal.
	evaluator := Object evaluatorClass.
	prevVers := nil.
	nextVers := [:vers | "vers has been encountered -> previous version is complete"
			prevVers == nil ifFalse: [self version: prevVers].
			prevVers := vers].
	section := aStream -> nil.

	[aStream skipSeparators; atEnd]
		whileFalse: 
			[| scanMode pos chunk |
			scanMode := aStream peekFor: $!!.
			pos := aStream position.
			chunk := aStream nextChunk.
			val := signal
				handle: [:ex | "provide source ref for some do its (e.g. class comment)"
					ex proceedWith: (SourceReference for: self position: pos)]
				do: [evaluator evaluate: chunk logged: false].
			scanMode
				ifTrue: [val scanFrom: aStream sourceHolder: self]
				ifFalse:
					["check for special commands"
					((val := self evaluateSpecial: val chunk: chunk mode: section)
						isKindOf: VersionDescriptor)
						ifTrue: [stopVersion = (nextVers value: val) ifTrue: [^val]]]
			].
	nextVers value: prevVers.
	^val! !

!Application methodsFor: 'private-fileIn/Out'!

fileInFrom: aStream stop: stopVersion external: aBoolean 
	"if aBoolean is true perform a special file-in (see #fileInExternal:stop:);
	otherwise file in up to end of file (rewritten from PeekableStream>fileIn)"

	| val signal compiler |
	aBoolean ifTrue: [^self fileInExternal: aStream stop: stopVersion].
	signal := self applicationManagement class sourceSignal.
	compiler := Object evaluatorClass.
	[aStream skipSeparators; atEnd]
		whileFalse: 
			[| scanMode |
			scanMode := aStream peekFor: $!!.
			val := signal
					handle: [:ex | 
						"handle here to inhibit handler search higher in the stack
						(further handlers can be found during nested file-in)"
						ex proceed]
					do: [compiler evaluate: aStream nextChunk logged: scanMode not].
			scanMode ifTrue: [val scanFrom: aStream]].
	^val! !

!Application methodsFor: 'fileIn/Out'!

fileInFrom: aStream start: startVersion stop: stopVersion external: aBoolean
	"file in from aStream: 
	start at first occurence of startVersion (current position if nil), 
	stop at occurence of stopVersion (or at end of stream); 
	changes are logged by the receiver; 
	keep source pointers to aStream (holder for the file is the receiver, 
	so take care that aStream is a stream on the receivers source file)"

	aBoolean ifTrue: [self path == nil
			ifTrue: [self label path: aStream name]
			ifFalse: [self instSourceFilename asString = aStream name
				ifFalse: [self notify: 'Attempt to assign a second source file']]].
	startVersion == nil
		ifFalse: [aStream position: (self getMinorVersionPosition: startVersion)].

	^self applicationManagement logTo: self while:
		[Cursor read showWhile:
			[[self fileInFrom: aStream stop: stopVersion external: aBoolean]
				valueNowOrOnUnwindDo: [aStream close]]]! !

!Application methodsFor: 'version management'!

upgradeMinorUpTo: aVersion
	"file in all the new sources in the receiver's source file:
	- start with the receiver's following minor version
	- stop at the beginning of aVersion (file in all if argument is nil)"

	| oldChanges newChanges chgList |
	oldChanges := self changes.
	self noChanges.
	"use a private copy of the source file accessor"
	self 
		fileInFrom: self instSourceFilename readStream
		start: self version newMinor
		stop: (aVersion == nil ifFalse: [aVersion newMinor])
		external: true.

	oldChanges isEmpty ifFalse:
		[oldChanges
			addDoIt: '"the following changes result from upgrade"';
			addAll: (newChanges := self changes)].
	self clearChanges.	"move upgrade changes to history"

	"user interaction for unsaved temporary changes"
	oldChanges isEmpty ifTrue: [^self].
	chgList := (EnhancedChangeList onApplication: self)
			listName: 'Changes conflicts in upgrading ' , self identifier storeString 
			changes: oldChanges
			removed: newChanges.

	DialogView userInfo: 
'The temporary changes have been removed from application.
Select "remove selection" for those you want to forget,
select "reinstall" for those which have been overwritten,
select "accept" to assign the contents of the list to the application.'.
 
	ChangeSequenceView openOn: chgList! !

!Application methodsFor: 'version management'!

upgradeMinor
	"file in all new sources in the receiver's source file: 
	start with the receiver's following minor version, stop at end of file"

	self hasUpgrade ifFalse: [^self].	"nothing to upgrade"
	self upgradeMinorUpTo: nil! !

!ApplicationManagement methodsFor: 'fileIn/Out'!

upgradeMinor: anApplicationOrNil 
	"upgrade the given application to a higher minor version;
	if argument is nil show applications with new versions and request from user"

	| app latest version |
	(app := anApplicationOrNil) == nil 
		ifTrue: [app := self upgradeApplications select: 'Select an application to upgrade' fromUserIfEmpty: [^nil]].
	(latest := app latestMinor) <= app version
		ifTrue: [^DialogView userInfo: 'No upgrade available'].
	version := DialogView
				request: 'Upgrade application ''', app identifier, '''\up to minor version' withCRs
				initialAnswer: latest minor printString
				ifEmpty: [^self].
	(version := Integer readFromString: version) <= app minorVersion
		ifTrue: [^self].
	
	app upgradeMinorUpTo: (version >= latest minor ifFalse: [VersionDescriptor major: latest major minor: version])! !

!ApplicationManagement methodsFor: 'fileIn/Out'!

fileInFrom: aStream to: anApplication external: aBoolean 
	"file in source code; 
	if 'aBoolean' is true, all changes will directly be assigned to 'anApplication'
	and the source code pointers will be directed to the source file just read;
	otherwise changes will pass through system change set and reach 'anApplication' "

	| result |
	result := anApplication fileInFrom: aStream start: nil stop: nil external: aBoolean.
	self updateApplicationList.
	^result! !

Application removeSelector: #fileInFromStream:startAt:stopAt:external:!

PeekableStream removeSelector: #fileInFrom:to:sources:!

PeekableStream removeSelector: #fileInUpTo:sources:!

"bug fixes:
- unh.ex. ERROR_SHARING_VIOLATION during minor versioning (DOS only)
- mnu #isEmpty during major version with rename
- invalid application browser models after major version with rename
- request platform names on major version with rename
- improper installation ordering for multiply required applications

modifications:
- save the confirm dialog during major versioning"!

!Application methodsFor: 'version management'!

newMinorVersion
	"increment the minor version number; 
	save current changes to source file and history, redirect source code pointers;
	broadcast the change of version to dependent browsers;
	return nil if any error or cancel from user occurs"

	| latest file |
	self version isInitialVersion ifTrue:
		[DialogView userError: 'Minor versions are not allowed\before the first major version release' withCRs. ^nil].

	self changes isEmpty ifTrue:
		[(DialogView confirm: 'There are no changes.\Do you want a new minor version anyway?' withCRs initialAnswer: false)
			ifFalse: [^nil]].

	(latest := self latestMinor) > self version ifTrue:
		[DialogView userError: ('This application has already been released to version\', latest printString, '\Try to upgrade and make your release afterwards') withCRs. ^nil].

	latest < self version copy untouch
		ifTrue: [(DialogView confirm: ('This application has not been released since version\', latest printString, '\Do you want to proceed?') withCRs initialAnswer: false)
			ifFalse: [^nil]].

	self releaseSourceFile.	"avoid problems with SHARE.EXE"
	file := OSErrorHolder noPermissionsSignal
		handle: [:ex |
			DialogView warn: ex signal errorString, '.\You are not allowed to create the new minor version' withCRs. ^nil]
		do: [self instSourceFilename makeWritable].

	[self fixChanges: true] valueNowOrOnUnwindDo: [file makeUnwritable]! !

!Application methodsFor: 'version management'!

newMajorVersion
	"create (and return) a new application, leave the old one for history references;
	create a subdirectory structure for storing a new major version,
	make a full store of all the associated stuff (e.g. sources etc.);
	forget changes since last minor version release, they won't get
	reliable source references"

	| newApp newName newMajor major |
	"- assign a new name ---------------------------"
	newName := DialogView
			request: 'Enter the name of the new major version of\''' withCRs, self identifier , ''''
			initialAnswer: self name
			ifEmpty: [^self].
	newApp := self cleanUp; copy.
	self name = newName
		ifFalse: [(DialogView confirm: 'You entered ''', newName, '''\as new application name.\Is this correct?' withCRs)
			ifTrue:
				[newApp label name: newName.
				newApp requestPlatformNamesOnCancel: [DialogView userInfo: 'Operation cancelled'. ^self]]
			ifFalse: [^self]].

	"- assign a new path ---------------------------"
	(newApp requestPath: #path) == nil
		ifTrue: [DialogView userInfo: 'Operation cancelled'. ^self].

	"- assign a new major version number ----------------"
	newMajor := DialogView
				request: 'New major version?'
				initialAnswer: ((major := self majorVersion) + 1) printString
				ifEmpty: [^self].
	(newMajor := Integer readFromString: newMajor) > 0
		ifFalse: [DialogView userError: 'Major numbers must be greater than zero'. ^self].

	newMajor - major > 1
		ifTrue: [(DialogView confirm: 'The major number increment is greater than 1.\Do you want to proceed?' withCRs initialAnswer: false)
			ifFalse: [^self]]
		ifFalse: [newMajor <= major
			ifTrue: [newApp directory = self directory
				ifTrue: [DialogView userError: 'You must specify a new path\if an old major number is used.' withCRs. ^self]]].
	newApp version: (VersionDescriptor major: newMajor - 1 minor: 0).

	newApp history isEmpty
		ifFalse: [(DialogView confirm: 'Do you want to the history be forgotten?')
			ifTrue: [newApp setHistory: ChangeSequence new]].

	"- basic storing sequence ---------------------------"
	newApp incrementMajorVersion; storeSource; storePools; noChanges.
	self applicationManagement unregister: self; register: newApp.
	self asBackup; changed: #application with: newApp.
	newApp storeBinary.
	^newApp! !

!ApplicationManagement methodsFor: 'fileIn/Out'!

fileInAsApplication: aFilename 
	"file in source code from a file named by the given filename object;
	the first chunk must be an application source header holding the application name;
 	redirect the source code pointers to the source file"

	| stream header appName appVers app old pathAndName |

	header := String readFrom: (stream := aFilename readStream).
	stream nextChunk; close. 
	(Application sourceHeader , '*(*.*)' match: header)
		ifFalse: [^self error: aFilename asString, '\is not an application source file' withCRs].
	(header := header readStream) skip: Application sourceHeader size.
	appName := header upTo: $(.
	appVers := VersionDescriptor readFrom: header.

	(old := self applicationNamed: appName) == nil
		ifFalse: [(DialogView confirm: ('Do you want to overwrite\''', old identifier, ''' ?', (old changes isEmpty ifTrue: [''] ifFalse: ['\(changes will get lost)'])) withCRs initialAnswer: false)
			ifTrue: [self unregister: old]
			ifFalse: [Transcript show: 'aborted '. ^nil]].

	(app := self newApplicationNamed: appName) == nil
		ifTrue: [^nil].

		"an application source path includes a basic path,
		followed by a major and a minor directory and the source file name;
		strip off the last three ones"
	pathAndName := aFilename head asFilename head asFilename.
	app label
		path: pathAndName head;
		setFilename: pathAndName tail forPlatform: OSHandle currentOS.
	app version: appVers.

	self do: [self fileInFrom: stream to: app external: true]
		onCancel:
			[self unregister: app.
			old == nil ifFalse: [self register: old].
			Transcript show: 'aborted '. ^nil].
	app setChanges: (app changes select: [:chg | chg isBackup]); clearChanges.

	old == nil ifFalse:
		[old changed: #application with: app.
		self browseConflicts: (app checkConflictsWith: old)].
	^app! !

!ApplicationManagement methodsFor: 'fileIn/Out'!

load: application from: aBOS path: path 
	"load the application (structure with class & method definitions) from aBOS;
	assign the given path after installation"

	| app old conflicts |
	Transcript cr; show: 'loading ' , application asString, ' (structure)... '.
	aBOS resizeMaps: aBOS nextIndex // 4 * 3 // 2.	"avoid growing of the bos' maps"
	app := Cursor read showWhile: [[aBOS next] valueNowOrOnUnwindDo: [aBOS close]].

	(old := self applicationNamed: app name) == nil
		ifFalse: [(DialogView confirm: ('Do you want to overwrite\''', old identifier, ''' ?', (old changes isEmpty ifTrue: [''] ifFalse: ['\(changes will get lost)'])) withCRs initialAnswer: false)
			ifTrue:
				[conflicts := app checkConflictsWith: old.
				self unregister: old]
			ifFalse: [Transcript show: 'aborted '. ^nil]].

	"set the correct path"
	app label path: path.
	Transcript show: '(checks)... '.
	self do: [self logTo: app while: [self checkRequired: app necessary]]
		onCancel:
			[old == nil ifFalse: [self register: old].
			Transcript show: 'aborted '. ^nil].

	[Transcript show: '(pre-installation)... '.
	app preInstallation do: [:chg | Compiler evaluate: chg text logged: true].

	Transcript show: '(source)... '.
	self logTo: app while: [Cursor read showWhile: [aBOS sourceMode: #reference; nextClasses; close]].

	Transcript show: '(post-installation)... '.
	app postInstallation do: [:chg | Compiler evaluate: chg text logged: true].

	app setChanges: (app changes select: [:chg | chg isBackup]); clearChanges; definePoolDictionaries.
	Transcript show: 'done ']

		valueNowOrOnUnwindDo: [self register: app].

	old == nil ifFalse:
		[old changed: #application with: app.
		self browseConflicts: conflicts].
	^app! !

!ApplicationManagement methodsFor: 'fileIn/Out'!

fileOutInstallation: anApplication on: instFilename path: dirFilename platform: aString 
	"create a file <instFilename> (if argument is not nil) with code to install 
	anApplication and (recursively) all its sub-applications; if aString is 
	- nil : do not copy the sources, use application paths during installation 
	- platform specifier : copy the application directory tree to <dirFilename>, 
		obeying platform characteristics, loading will search the path of the 
		installation file at execution time"

	| required drop apps abort |
	required := (apps := anApplication necessary) isEmpty
		ifTrue: [apps]
		ifFalse: [ApplicationBrowser multipleSelect: apps prompt: 'include applications' onCancel: [^self]].

	abort := [:msg | (DialogView confirm: (msg , '\Proceed without it?') withCRs)
				ifFalse: [^self]].
	apps := apps collect: [:appName | self applicationNamed: appName
				ifAbsent: [abort value: 'Application ''' , appName , ''' is not loaded.']].
	drop := apps removeAllSuchThat: [:app | app == nil or: [(required includes: app name) not]].
	required := apps.

	"recursively collect required applications; sort wrt. sub-application property"
	(apps := Dictionary new: required size * 4) at: anApplication put: 0.
	required do: [:app | apps at: app put: 1].
	Object notifySignal handle: [:ex | abort value: ex errorString]
		do: [required do: [:app | app
				subApplicationsDo: [:ap :lev | apps at: ap put: (lev max: (apps at: ap ifAbsent: [lev]))]
				level: 2
				skip: drop]].
	apps := (apps associations asSortedCollection: [:x :y | x value > y value])
				collect: [:assoc | assoc key].

	aString == nil ifFalse: ["make sure that the target platform filenames are defined"
		apps do: [:app | app label filenameForPlatform: aString ifNone: [app
					requestPlatformNamesOnCancel: 
						[DialogView userInfo: 'Installation file out aborted.'.
						^nil]]]].

	Cursor write showWhile: 
		[instFilename == nil ifFalse:
			[(self fileOutInstallScript: apps platform: aString on: instFilename) == nil ifTrue: [^self]].
		aString == nil ifTrue: [^self].
		Transcript cr; show: 'copying sources...'.
		apps do: 
			[:app | 
			Transcript crtab; show: app name , '...'.
			((app exportForPlatform: aString destinationPath: dirFilename) == nil 
				and: [DialogView confirm: 'Do you want to abort the installation file out?'])
				ifTrue: [^self]].
		Transcript cr; show: 'done.']! !

"code maintenance"!

!Application methodsFor: 'version management'!

latestMinor
	"return a VersionDescriptor for the latest version string in the source file"

	^(self version isInitialVersion or: [self versionFileName exists not])
		ifTrue: [self version]
		ifFalse: 
			[| pos |
			pos := ChangeList new findLast: (self class sourceHeader , self name copyWith: $() in: self sourceFile.
			VersionDescriptor readFrom: (self sourceFile position: pos)]! !

!Application methodsFor: 'testing'!

hasUpgrade
	"return true if there are new sources since the last file in"

	^self latestMinor > self version! !

!Application methodsFor: 'private'!

touch
	"mark that a change occurred"

	self version touch! !

!ApplicationManagement methodsFor: 'logging on/off/redirect'!

logTo: anApplication while: aBlock 
	"execute aBlock (typically a file in), log changes into anApplication;
	logging to system application is equivalent to 'logTo==nil' "

	| save logApp |
	logApp := anApplication == system ifFalse: [anApplication].
	(save := logTo) == logApp	"nothing changed"
		ifTrue: [^aBlock value].

	Transcript cr; nextPutAll: 'Logging to '; print: anApplication; space; endEntry.
	logTo := logApp.
	^aBlock valueNowOrOnUnwindDo:
		[logTo := save.
		Transcript cr; nextPutAll: 'Logging back to '; print: (save == nil ifTrue: [system] ifFalse: [save]); space; endEntry]! !

ApplicationManagement removeSelector: #resetLogging!

ApplicationManagement class removeSelector: #findBackupsFor:!


' .ApplicationSource APL-Framework(1.17)'!
'From VisualWorks(R) Release 2.0 of 4 August 1994 on 16 February 1995 at 3:04:12 pm'!



!Application methodsFor: 'private'!

incrementMinorVersion
	self version: self version newMinor! !

"no dialog on binary storage of foreign applications"!

!ApplicationBOSSWriter methodsFor: 'private-tracing'!

traceApplication: anApplication 
	"if the argument is the main application currently being stored then store as 
	usual (recursively); otherwise return an expression which requests the 
	argument from existing applications"

	^anApplication == application
		ifTrue: [self traceDefault: anApplication]
		ifFalse: 
			[| expr |
			Transcript nextPutAll: ' (reference on '''; print: anApplication; show: ''')'.
			expr := 'self applicationManagement applicationNamed: % ifAbsent: [%]'
				copyReplaceAll: '%' with: anApplication name storeString.
			MessageSend
				receiver: Object evaluatorClass
				selector: #evaluate:
				arguments: (Array with: expr)]! !


' .ApplicationSource APL-Framework(1.18)'!
'From VisualWorks(R) Release 2.0 of 4 August 1994 on 3 March 1995 at 5:36:35 pm'!



"feed installation scripts with better parameters"!

!ApplicationManagement methodsFor: 'fileIn/Out'!

fileOutInstallScript: sortedApplications platform: aString on: aFilename
	"write out code which installs applications in given order; if aString is nil,
	loading will search the path of the installation file at execution time;
	otherwise the paths of the applications will be used"

	| export specs stamp template |
	export := aString notNil.
	specs := sortedApplications collect: [:app | Array
				with: app name
				with: app majorVersion
				with: (export ifFalse: [app path asString])
				with: (export ifTrue: [app label filenameForPlatform: aString] ifFalse: [app fileString])].
	self timeStamp: (stamp := WriteStream on: (String new: 100)).

	template := (self applicationNamed: 'APL-Framework') minorDirectory / 'insttmpl.txt'.
	template := OSErrorHolder errorSignal
		handle:
			[:ex | 
			DialogView warn: 'Could not read template file ''insttmpl.txt''\in path of ''APL-Framework''\(' withCRs, ex errorString, ')'.
			^nil]
		do: [template asFilename contentsOfEntireFile].

	template := ((template copyReplaceAll: '$APPID' with: sortedApplications last identifier)
				copyReplaceAll: '$TIMESTAMP' with: stamp contents)
				copyReplaceAll: '$APPLICATIONSPECS' with: specs asArray printString.
	aFilename writeStream nextPutAll: template; close! !


' .ApplicationSource APL-Framework(1.19)'!
'From VisualWorks(R) Release 2.0 of 4 August 1994 on 10 April 1995 at 4:53:36 pm'!



"bug fix:
- major versioning sometimes left old application references
	in changes of other applications (e.g. major versions with rename)
- class renames have to be propagated immediately to all change sequences"!

!ApplicationManagement methodsFor: 'change management'!

updateChangesForMajor: anApplication previous: prevApplication 
	"prevApplication has been saved by a new major version (anApplication); 
	update source code references held by other applications (usually backups)"

	| hist |
	hist := anApplication history.
	applications do: [:app | app changes removeAllSuchThat:
		[:chg | | srcref |
		(srcref := chg file) class == SourceReference
			and: [srcref sourceFileHolder == prevApplication
			and: 
				[| txt chg2 |
				txt := chg text.
				(chg2 := hist findLast: [:ch | ch text = txt]) = 0
					or: 
						[chg file: (hist at: chg2) file copy position: nil.
						false]]]]]! !

!ApplicationManagement methodsFor: 'version management'!

newMajorVersion: anApplication previous: prevApplication
	"prevApplication has been saved by a new major version (anApplication); 
	update references to the old version"

	self
		unregister: prevApplication;
		register: anApplication;
		updateChangesForMajor: anApplication previous: prevApplication! !

!Application methodsFor: 'version management'!

newMajorVersion
	"create (and return) a new application, leave the old one for history references;
	create a subdirectory structure for storing a new major version,
	make a full store of all the associated stuff (e.g. sources etc.);
	forget changes since last minor version release, they won't get
	reliable source references"

	| newApp newName newMajor major |
	"- assign a new name ---------------------------"
	newName := DialogView
			request: 'Enter the name of the new major version of\''' withCRs, self identifier , ''''
			initialAnswer: self name
			ifEmpty: [^self].
	newApp := self cleanUp; copy.
	self name = newName
		ifFalse: [(DialogView confirm: 'You entered ''', newName, '''\as new application name.\Is this correct?' withCRs)
			ifTrue:
				[newApp label name: newName.
				newApp requestPlatformNamesOnCancel: [DialogView userInfo: 'Operation cancelled'. ^self]]
			ifFalse: [^self]].

	"- assign a new path ---------------------------"
	(newApp requestPath: #path) == nil
		ifTrue: [DialogView userInfo: 'Operation cancelled'. ^self].

	"- assign a new major version number ----------------"
	newMajor := DialogView
				request: 'New major version?'
				initialAnswer: ((major := self majorVersion) + 1) printString
				ifEmpty: [^self].
	(newMajor := Integer readFromString: newMajor) > 0
		ifFalse: [DialogView userError: 'Major numbers must be greater than zero'. ^self].

	newMajor - major > 1
		ifTrue: [(DialogView confirm: 'The major number increment is greater than 1.\Do you want to proceed?' withCRs initialAnswer: false)
			ifFalse: [^self]]
		ifFalse: [newMajor <= major
			ifTrue: [newApp directory = self directory
				ifTrue: [DialogView userError: 'You must specify a new path\if an old major number is used.' withCRs. ^self]]].
	newApp version: (VersionDescriptor major: newMajor - 1 minor: 0).

	newApp history isEmpty
		ifFalse: [(DialogView confirm: 'Do you want to the history be forgotten?')
			ifTrue: [newApp setHistory: ChangeSequence new]].

	"- basic storing sequence ---------------------------"
	newApp incrementMajorVersion; storeSource; storePools; noChanges.
	self applicationManagement newMajorVersion: newApp previous: self.
	self asBackup; changed: #application with: newApp.
	newApp storeBinary.
	^newApp! !

!ApplicationManagement methodsFor: 'change management'!

renameClass: class as: newName 
	"inform applications that class is renamed"

	logging ifFalse: [^self].
	applications do: [:app | app renameClass: class as: newName]! !

!Application methodsFor: 'changing-classes'!

renameClass: aClass as: newName 
	"rename aClass' subset and reenter it under the new key; 
	add a rename change if the receiver defines aClass"

	| rename subset metaName |
	rename := false.
	(subset := self removeClassSubset: aClass) isNil
		ifFalse: 
			[subset renameTo: newName.
			classes at: newName asSymbol put: subset.
			rename := subset includesDefinition].
	(subset := self removeClassSubset: aClass class) isNil
		ifFalse: 
			[metaName := (newName , ' class') asSymbol.
			subset renameTo: metaName.
			classes at: metaName put: subset.
			rename := rename | subset includesDefinition].
	rename
		ifTrue: 
			[self changes renameClass: aClass name to: newName.
			self touch]
		ifFalse: [self changes renameAllClass: aClass name to: newName]! !

"code maintenance"!

Application removeSelector: #sourceIdentifierForVersion:!

ApplicationManagement removeSelector: #changedApplications!

"ensure that binary storage does not use source code references pointing to the changes file"!

!BOSSWriter methodsFor: 'representation'!

representCompiledMethod: aCompiledMethod 
	"This is the representation method for compiled code objects, invoked from 
	CompiledMethod>>representBinaryOn:. It manages the saving and restoring 
	of the source code or source pointer."

	| mth src cls sel cat |
	src := (mth := aCompiledMethod shallowCopy) sourcePointer.
	mth sourcePointer: nil.
	sel := currentClass selectorAtMethod: aCompiledMethod setClass: [:c] ifAbsent: [].
	cls := aCompiledMethod mclass.
	cat := Object errorSignal handle: [:ex | ex return]
				do: [cls whichCategoryIncludesSelector: sel].
	src == nil ifFalse: [useSource == #keep
		ifTrue: [src := aCompiledMethod getSource]
		ifFalse: [useSource == #reference
			ifTrue: [(SourceFileManager default fileIndexFor: src) = 2
				ifTrue:
					["the changes file is not safe for reference transfer"
					self notify: ('Invalid source code reference\for %>%'
								withArgs: (Array with: cls name with: sel)).
					src := nil]]
			ifFalse: [src := nil]]].
	^BinaryObjectStorage indexImportCompiledCode -> (BOSSCompiledCodeHolder new
			class: cls
			selector: sel
			category: cat
			codeClass: aCompiledMethod class
			codeContents: (mth changeClassToThatOf: #())
			source: src)! !


' .ApplicationSource APL-Framework(1.20)'!
'From VisualWorks(R) Release 2.0 of 4 August 1994 on 21 April 1995 at 3:17:25 pm'!



"copy latest major version only during installation export"!

!Application methodsFor: 'fileIn/Out'!

exportForPlatform: aString destinationPath: dirFilename 
	"copy the directory of the receiver (without old major versions) 
	to directory dirFilename; return nil if errors occur (self otherwise)"

	| src dest maj srcfile |
	(src := self directory) = (dest := (dirFilename / (self filenameForPlatform: aString)) asFilename)
		ifTrue: 
			[DialogView userError: ('''%''\is invalid as export directory.' withArgs: dirFilename).
			^nil].
	OSErrorHolder existingReferentSignal handle: [:ignore] do: [dest makeDirectory].
	src := src / (maj := 'v' , self majorVersion printString).
	dest := dest / maj.
	srcfile := (dest / 's.st') asFilename.
	"careful if some previous export created a read-only file"
	OSErrorHolder errorSignal handle: [:ignore] do: [srcfile makeWritable].
	[src asFilename copyRecursiveTo: dest]
		valueNowOrOnUnwindDo:
			[OSErrorHolder errorSignal handle: [:ignore] do: [srcfile makeUnwritable]]! !

"bug fix: mnu ClassDefinitionChange>type during class redefinition"!

!Application methodsFor: 'changing-classes'!

changeOrIncludeClass: aClass 
	"definition of aClass changed in the scope of the receiver; include it with 
	definition if necessary, and make backup, include/change entries to changes"

	| bak |
	bak := self changes backupClass: aClass.
	(self includesClass: aClass)
		ifTrue: [self changes changeClass: aClass]
		ifFalse: 
			[self includeClass: aClass.
			(bak == nil or: [bak isBackup])
				ifTrue: 
					["class is new or truely changed; replace the include change"
					| chg |
					((chg := self changes last) className == aClass name
						and: [chg class == ClassApplicationChange])
						ifTrue: [self changes removeLast; changeClass: aClass]]]! !