
' .ApplicationSource X_OS-Support(1.0)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 20 May 1994 at 11:33:28 am'!



'- sources of X_OS-Support(1.0) -'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!OSErrorHolder class methodsFor: 'error reporting'!

errorDescriptionFor: aSmallInteger 
	"return a string describing the error"

	<primitive: 697>
	^(self errorSignalFor: aSmallInteger) errorString!

reportOn: anErrorHolder 
	"As an error reporter, report the error contained by this holder."
	"This means, map the error holder's error code to the error name, 
	map the error name to an error signal, and raise the signal."

	| errorSignal |
	errorSignal := self errorSignalFor: anErrorHolder errorCode.
	^errorSignal raiseWith: anErrorHolder errorString: anErrorHolder errorString!

reportProceedingOn: anErrorHolder 
	"As an error reporter, report the (proceedable) error contained by this holder."
	"This means, map the error holder's error code to the error name, 
	map the error name to an error signal, and raise the signal."

	| errorSignal |
	errorSignal := self errorSignalFor: anErrorHolder errorCode.
	^errorSignal raiseRequestWith: anErrorHolder errorString: anErrorHolder errorString! !

!OSErrorHolder class methodsFor: 'private'!

errorSignalFor: aSmallInteger 
	"return a signal announcing the error with code aSmallInteger; 
	return the unsupported-operation-signal if the argument is nil; 
	return the default error signal if the code cannot be resolved"

	^aSmallInteger == nil
		ifTrue: [self unsupportedOperationSignal]
		ifFalse: [self errorSignalFor: aSmallInteger ifAbsent: [self errorSignal]]!

errorSignalFor: aSmallInteger ifAbsent: aBlock 
	"return a signal announcing the error with code aSmallInteger; 
	return the result of aBlock if the code cannot be resolved"

	^self errorSignals at: (self errorSymbolFor: aSmallInteger)
		ifAbsent: [aBlock value]!

primErrorName: code
	"return the error name for this code"

	<primitive: 696>
	"the virtual machine for OS/2 seems to fail in accessing the error name;
	try to repair; maybe, this is not the best place to do, but it works"
	^Filename defaultClass name == #OS2Filename
		ifTrue: [OS2ErrorHolder errorSymbolFor: code]
		ifFalse: ["default is nil"]! !



OSErrorHolder subclass: #OS2ErrorHolder
	instanceVariableNames: ''
	classVariableNames: 'Os2ErrorCodeMap '
	poolDictionaries: ''
	category: 'OS-Support'!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!OS2ErrorHolder class methodsFor: 'class initialization'!

initErrorCodeMap
	"this map includes only those errors which are not mapped properly by default"
	"OS2ErrorHolder initialize"

	Os2ErrorCodeMap := Dictionary new
		at: 3 put: 'ERROR_PATH_NOT_FOUND';
		at: 4 put: 'ERROR_TOO_MANY_OPEN_FILES';	"(no handles left)"
		at: 5 put: 'ERROR_ACCESS_DENIED';
		at: 19 put: 'ERROR_WRITE_PROTECT';	"attempt to write on write-protected diskette"
		at: 21 put: 'ERROR_NOT_READY';	"Drive not ready"
		at: 110 put: 'ERROR_OPEN_FAILED';   "open/create failed due to explicit fail command"
		at: 123 put: 'ERROR_INVALID_NAME';	"Illegal character or invalid file-system name"
		yourself.!

initErrorNameSignalMap
	"this map includes only those errors which are not mapped properly by default;
	just add them to the global error name signal map"
	"OS2ErrorHolder initialize"

	self errorSignals
		at: 'ERROR_PATH_NOT_FOUND' put: self nonexistentSignal;
		at: 'ERROR_TOO_MANY_OPEN_FILES' put: self noResourcesSignal;
		at: 'ERROR_ACCESS_DENIED' put: self noPermissionsSignal;
		at: 'ERROR_WRITE_PROTECT' put: self noPermissionsSignal;
		at: 'ERROR_NOT_READY' put: self notReadySignal;
		at: 'ERROR_OPEN_FAILED' put: self nonexistentSignal;
		at: 'ERROR_INVALID_NAME' put: self invalidArgumentsSignal!

initialize
	"OS2ErrorHolder initialize"

	self initErrorCodeMap; initErrorNameSignalMap! !

!OS2ErrorHolder class methodsFor: 'error reporting'!

errorSymbolFor: code 
	"return the error name string for the given error code"

	^Os2ErrorCodeMap at: code ifAbsent: ['unknown']! !

OS2ErrorHolder initialize!




' .ApplicationSource X_OS-Support(1.1)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 24 May 1994 at 4:58:49 pm'!



!OS2ErrorHolder class methodsFor: 'class initialization'!

initErrorCodeMap
	"this map includes only those errors which are not mapped properly by default"
	"OS2ErrorHolder initialize"

	Os2ErrorCodeMap := Dictionary new
		at: 3 put: 'ERROR_PATH_NOT_FOUND';
		at: 4 put: 'ERROR_TOO_MANY_OPEN_FILES';	"(no handles left)"
		at: 5 put: 'ERROR_ACCESS_DENIED';

		at: 15 put: 'ERROR_INVALID_DRIVE';	"attempt to read a non-existent volume"
		at: 19 put: 'ERROR_WRITE_PROTECT';	"attempt to write on write-protected diskette"
		at: 21 put: 'ERROR_NOT_READY';	"Drive not ready"
		at: 110 put: 'ERROR_OPEN_FAILED';   "open/create failed due to explicit fail command"
		at: 123 put: 'ERROR_INVALID_NAME';	"Illegal character or invalid file-system name"
		yourself.! !

!OS2ErrorHolder class methodsFor: 'class initialization'!

initErrorNameSignalMap
	"this map includes only those errors which are not mapped properly by default;
	just add them to the global error name signal map"
	"OS2ErrorHolder initialize"

	self errorSignals
		at: 'ERROR_PATH_NOT_FOUND' put: self nonexistentSignal;
		at: 'ERROR_INVALID_DRIVE' put: self nonexistentSignal;
		at: 'ERROR_TOO_MANY_OPEN_FILES' put: self noResourcesSignal;
		at: 'ERROR_ACCESS_DENIED' put: self noPermissionsSignal;
		at: 'ERROR_WRITE_PROTECT' put: self noPermissionsSignal;
		at: 'ERROR_NOT_READY' put: self notReadySignal;
		at: 'ERROR_OPEN_FAILED' put: self nonexistentSignal;
		at: 'ERROR_INVALID_NAME' put: self invalidArgumentsSignal! !

OS2ErrorHolder initialize!