' .ApplicationSource APL-Interface(1.8)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 27 September 1994 at 12:05:11 pm'!



"fix: file i/o error during statistics function"!

!ApplicationBrowser methodsFor: 'private-application functions'!

spawnStatistics
	"open a workspace with statistical informations about the application"

	| s a |
	(s := TextStream on: (String new: 500))
		nextPutAll: 'classes:'; tab: 2; print: (a := self application) classNames size; space; nextPut: $(; print: a ownClassNames size; nextPut: $); cr;
		nextPutAll: 'selectors:'; tab: 1; print: a selectors size; cr.

	a path notNil ifTrue:
		[s nextPutAll: 'sources:'; tab: 2; print: (OSErrorHolder nonexistentSignal
				handle: [:ex | ex returnWith: 0]
				do: [a sourceFile name asFilename fileSize]); cr.
		a version isInitialVersion ifFalse:
			[s nextPutAll: 'binary:'; tab: 2; print: (OSErrorHolder nonexistentSignal
				handle: [:ex | ex returnWith: 0]
				do: [a instBossFilename fileSize]); cr]].

	s := s contents.
	ComposedTextView
		open: (ValueHolder with: s)
		label: 'Statistics on ' , a identifier storeString
		icon: (Icon constantNamed: #workspace)
		extent: s asComposedText extent + 30! !


' .ApplicationSource APL-Interface(1.9)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 15 February 1995 at 9:19:10 pm'!



"fix: (see also APL-Framework(1.15) and higher)
- mnu #isEmpty during major version with rename
- invalid application browser models after major version with rename
- update the browser when accepting code
- switch to system mode after 'find class' if necessary
- error when entering an empty string as platform compatible name
- errors in ApplicationBrowser class>openOn:/open
- no update on AppMan browser list if selected entry is outdated
	(avoid irritation or loss of selection)"!

!ApplicationBrowser methodsFor: 'updating'!

newApplicationVersion
	"the application version has changed; update window label and info text"

	self newApplicationInfo; changed: #windowLabel with: self application identifier! !

!ApplicationBrowser methodsFor: 'initialize-release'!

application: anApplication 
	"set or change the application of the browser; 
	install the browser as dependent, release old dependency if any; 
	update output concerning the application version"

	| initial |
	application == anApplication ifTrue: [^self].
	(initial := application == nil) ifFalse: [application removeDependent: self].
	(application := anApplication) addDependent: self.
	initial ifFalse: [self newApplicationVersion].
	self changed: #category! !

!ApplicationBrowser methodsFor: 'initialize-release'!

on: anApplication 
	"initialize the receiver to browse on anApplication"

	super on: Smalltalk organization.
	systemMode := documentationMode := false.
	self application: anApplication! !

!ApplicationBrowser methodsFor: 'updating'!

update: anAspect 
	"usually invoked by an application modification or minor version release"

	anAspect == #version ifTrue: [^self newApplicationVersion].
	super update: anAspect! !

!ApplicationBrowser methodsFor: 'updating'!

update: anAspect with: anApplication 
	"usually invoked by an application major version release"

	(anAspect == #application and: [anApplication isKindOf: Application])
		ifTrue: ["my application got a new major version, attach to the new object"
			^self application: anApplication].
	super update: anAspect with: anApplication! !

!ApplicationBrowser methodsFor: 'doIt/accept/explain'!

acceptText: aText from: aController 
	| bool |
	bool := self documentationMode
				ifTrue: [self acceptDocumentation: aText from: aController]
				ifFalse: [super acceptText: aText from: aController].
	^bool
		and: 
			[self newApplicationVersion.
			self applicationManagement updateApplicationList.
			true]! !

!ApplicationBrowser methodsFor: 'private-category functions'!

 !                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   

!ApplicationBrowser class methodsFor: 'dialogs'!

request: messageString platformNames: aDictionary default: aString onCancel: aBlock
	"open a dialog for entering compatible filenames; return the new dictionary"

	| platforms currentValues dialog cancel y1 newValues |
	currentValues := (platforms := StorableObjectAccessor supportedPlatforms)
		collect: [:platf | ValueHolder with: (aDictionary at: platf
			ifAbsent:
				["suggest a filename, indicated by a ?"
				| try |
				try := (Filename defaultClassForPlatform: platf)
					suggest: (platf == #dos | (platf == #os2)
						ifTrue: [aString copyFrom: 1 to: (aString size min: 8)]
						ifFalse: [aString]).
				try copyWith: $?])].

	dialog := DialogView model: (cancel := ValueHolder newBoolean).
	y1 := self title: messageString forDialog: (dialog width: 250).

	currentValues with: platforms do: [:vmodel :platform |
		y1 := dialog 
			yPosition: y1 + 10;
			addVisual: platform asComposedText fromX: 0 toX: 0.2;
			yPosition: y1 + 8;
			addTextFieldOn: vmodel initially: vmodel value fromX: 0.25 toX: 1;
			yPosition].
	self addButtons: #(accept cancel) for: dialog.
	dialog open.

	cancel value ifTrue: [^aBlock value].

	newValues := Dictionary new.
	currentValues with: platforms do: [:vmodel :platform | | fname cls guess |
		"discard the ? if any"
		((fname := vmodel value) isEmpty not and: [fname last == $?])
			ifTrue: [fname := fname copyFrom: 1 to: fname size -1].
		fname isEmpty ifFalse:
			["check validity"
			cls := Filename defaultClassForPlatform: platform.
			[(guess := cls suggest: fname) sameAs: fname]
				whileFalse:
					[fname := DialogView
						request: ('''', fname, ''' is not compatible to ', cls name, '.\Retry...' withCRs)
						initialAnswer: guess
						ifEmpty: [^aBlock value].
					(fname first = cls currentDirectoryString first or: [fname includes: cls separator])
						ifTrue: [fname := guess]].
			newValues at: platform put: fname]].
	^newValues! !

!ApplicationBrowser class methodsFor: 'view creation'!

openOn: anApplication 
	self
		openOn: (self new on: Smalltalk organization; application: anApplication)
		withTextState: nil! !

!ApplicationBrowser class methodsFor: 'view creation'!

open
	"select an application from Application Management and open a browser on it"

	| app |
	app := self applicationManagement selectApplication: 'Select an application to browse'.
	^app == nil ifFalse: [self openOn: app]! !

!ApplicationManagementBrowser methodsFor: 'application list'!

selectedApplication
	"returns the application object referred by the current selection"

	^application == nil
		ifFalse: 
			[| id |
			id := application string copyWithout: Character tab.
			management applicationNamed: (id copyUpTo: $()]! !

!ApplicationManagementBrowser methodsFor: 'application list'!

updateList
	"some applications changed their version; redisplay newest identifiers; 
	avoid losing the current selection if it is outdated"

	| app |
	(app := self selectedApplication) == nil
		ifFalse: 
			[app := app identifier.
			self hierarchy == nil
				ifFalse: 
					[| idx |
					idx := application string lastIndexOf: Character tab.
					app := ((application string copyFrom: 1 to: idx) , app) asText].
			self application: app].
	self changed: #application! !

!ApplicationManagementBrowser methodsFor: 'updating'!

update: anAspect 
	"usually invoked by a major/minor version release via application browser"

	anAspect == #version
		ifTrue:
			[ "this broadcast signals that an application's version changed"
			"avoid losing selection if selected item concerns about new version"
			^self updateList].
	super update: anAspect! !

"code maintenance"!

!ApplicationManagementBrowser methodsFor: 'menu messages'!

upgradeMinor
	"try to upgrade anApplication to the newest available minor version"

	management upgradeMinor: self selectedApplication! !

!ApplicationManagementBrowser methodsFor: 'menu messages'!

activateSelection
	"open an ApplicationBrowser on the selected application"

	Cursor execute showWhile: [self editApplication]! !

!ApplicationManagementBrowser methodsFor: 'menu messages'!

productInfo
	Cursor execute showWhile: [management class productInfo]! !

!ApplicationBrowser methodsFor: 'text'!

info
	"return source file name for selected method or class"

	| cls owners |
	(cls := self classOfSelectedMethod) == nil ifTrue: [^''].
	selector == nil 
		ifFalse:
			[| mth idx str |
			mth := cls compiledMethodAt: selector ifAbsent: [^''].
			(idx := mth fileIndex) isInteger ifFalse: [^idx sourceFileHolderId].
			str := self sourceFilename: idx.
			idx == 2 ifFalse: [^str].
			"provide a note if selector does not belong to edited application"
			(self application includesSelector: selector class: cls) ifTrue: [^str].
			owners := self applicationManagement applicationsIncludingSelector: selector class: cls.
			owners := owners isEmpty ifTrue: ['unregistered'] ifFalse: [owners first identifier].
			^str, ' (', owners, ')'].

	textMode == #comment
		ifTrue: [| src | 
			(src := self nonMetaClass organization globalComment) == nil
				ifTrue: [^''].
			^src class == SourceReference
				ifTrue: [src sourceFileHolderId]
				ifFalse: [self sourceFilename: src sourceFileNumber]].

	"test if class is defined in an application"
	(owners := self applicationManagement applicationsIncludingDefinition: cls) isEmpty
		ifFalse: [^owners first identifier].

	"test if class is in system changes"
	((ChangeSet current isNew: cls) or: [ChangeSet current atClass: cls includes: #change])
		ifTrue: [^self sourceFilename: SourceFileManager default target]. 

	"class must be defined by system sources"
	^self sourceFilename: 1! !

"enhancements: emphasize method comments"!

!Scanner methodsFor: 'public access'!

scanComments: textOrString do: aBlock
	"scan textOrString for comments, evaluate aBlock with start and end positions of each comment found"

	self on: textOrString readStream.
	[hereChar ~~ nil]
		whileTrue:
			["Skip delimiters fast, there almost always is one."
			[(tokenType := typeTable at: hereChar asInteger) == #xDelimiter]
				whileTrue:
					[(hereChar := source next) == nil ifTrue: [^self	"end of input"]].

			tokenType == #xDoubleQuote
				ifTrue:
					[| cmtStart char |
					cmtStart := source position.
					[(char := source next) == $"]
						whileFalse:
							[char == nil
								ifTrue: [^self offEnd: 'Unmatched comment quote']].
					aBlock value: cmtStart value: source position.
					hereChar := source next]
				ifFalse: [tokenType == #xLetter		"most tokens are words or keywords"
					ifTrue: [self xLetter]
					ifFalse: [(tokenType at: 1) = $x
						ifTrue: [self perform: tokenType]
						ifFalse: [hereChar := source next]]]]! !

!ApplicationBrowser methodsFor: 'text'!

emphasisFor: aSymbol 
	"return text emphasis to add to text classified by aSymbol"

	^aSymbol == #comment ifTrue: [#italic]! !

!ApplicationBrowser methodsFor: 'text'!

 !                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           


' .ApplicationSource APL-Interface(1.10)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 7 April 1995 at 6:36:19 pm'!



!ApplicationBrowser methodsFor: 'text'!

text
	"it is possible to add inherited selectors to the selector list, 
	so the selected class may be different from the implementing class;
	if there is no text, return a short info about the application"

	| text |
	self documentationMode ifTrue: [^self application documentation asText].
	textMode == #methodDefinition & selector notNil
		ifTrue:
			[| emph scn |
			text := self classOfSelectedMethod sourceMethodAt: selector.
			(emph := self emphasisFor: #comment) == nil ifFalse:
				["emphasize method comments"
				self errorSignal handle: [:ex | ex return] from: (scn := Scanner new) do:
					[scn scanComments: text string do:
						[:cmtStart :cmtEnd | text emphasizeFrom: cmtStart to: cmtEnd with: emph]]].
			^text].
	^(text := super text) isEmpty
		ifTrue: [self applicationInformation]
		ifFalse: [text]! !

!ApplicationBrowser methodsFor: 'private-category functions'!

findClass
	"Prompt for a class and position myself there; set system mode if necessary"

	| cls |
	self changeRequest ifFalse: [^self].
	(cls := self pickAClass: 'Find class:') = '' ifTrue: [^self].
	cls == nil ifTrue: [^DialogView warn: 'No matching class'].
	cls := cls isBehavior
			ifTrue: [cls isMeta ifTrue: [cls soleInstance] ifFalse: [cls]]
			ifFalse: [cls class].
	(self application includesClass: cls name)
		ifFalse: [self systemMode: true; changed: #systemMode].
	self newCategoryList: cls category; newClassList: cls name! !