' .ApplicationSource Version(1.2)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 23 December 1994 at 1:15:07 pm'!



"code maintainance"!

!VersionDescriptor class methodsFor: 'constants'!

modifier
	"return the character to mark modification"

	^$m! !

!VersionDescriptor class methodsFor: 'instance creation'!

major: majorNumber minor: minorNumber 
	"create a new version descriptor with major and minor version numbers"

	^super new major: majorNumber minor: minorNumber! !

!VersionDescriptor class methodsFor: 'instance creation'!

new
	^self major: 0 minor: 0! !

!VersionDescriptor class methodsFor: 'instance creation'!

readFrom: aStream 
	"scan a VersionDescriptor from aStream; 
	format: <white space><PositiveInteger>.<PositiveInteger>"

	| maj min |
	maj := aStream skipSeparators peek isDigit
			ifTrue: [Integer readFrom: aStream]
			ifFalse: ['(non-negative major version number expected)'].
	min := maj isInteger
			ifTrue: [aStream next == self separator
				ifTrue: [aStream peek isDigit
					ifTrue: [Integer readFrom: aStream]
					ifFalse: ['(non-negative minor version number expected)']]
				ifFalse: ['(''.'' expected)']]
			ifFalse: [maj].
	^min isInteger
		ifTrue: [(self major: maj minor: min)
				perform: (aStream peek == self modifier
					ifTrue: [aStream next. #touch]
					ifFalse: [#untouch])]
		ifFalse: [self error: 'Invalid version number ' , min]! !

VersionDescriptor class removeSelector: #readFromString:!

!VersionDescriptor methodsFor: 'printing'!

printOn: stream 
	stream print: self major; nextPut: self class separator; print: self minor.
	self modified ifTrue: [stream nextPut: self class modifier]! !

!VersionDescriptor methodsFor: 'initialize-release'!

major: majorNumber minor: minorNumber 
	"set major/minor numbers and reset the modification flag"

	minor := minorNumber.
	major := majorNumber.
	changed := false! !

VersionDescriptor removeSelector: #initialize!

VersionDescriptor removeSelector: #fileString!


' .ApplicationSource Version(1.3)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 23 January 1995 at 5:19:42 pm'!



"code maintenance"!

!VersionedObjectAccessor methodsFor: 'accessing'!

identifier
	^(WriteStream on: (String new: 32))
		nextPutAll: name;
		nextPut: $(;
		print: self version;
		nextPut: $); contents! !